<!DOCTYPE html>
<html lang="en">
<head>
  <title>67.S10</title>
  <meta charset="utf-8">
  <meta name="viewport" content="width=device-width, initial-scale=1">
  <link rel="stylesheet" href="https://maxcdn.bootstrapcdn.com/bootstrap/4.5.2/css/bootstrap.min.css">
  <script src="https://ajax.googleapis.com/ajax/libs/jquery/3.5.1/jquery.min.js"></script>
  <script src="https://maxcdn.bootstrapcdn.com/bootstrap/4.5.2/js/bootstrap.min.js"></script>

  <!-- Import Datatable sau jquery -->
  <!-- Import them style bootstrap cho datatable -->
  <link rel="stylesheet" href="https://cdn.datatables.net/1.10.24/css/dataTables.bootstrap4.min.css">
  <script src="https://cdn.datatables.net/1.10.24/js/jquery.dataTables.min.js"></script>
  <script src="https://cdn.datatables.net/1.10.24/js/dataTables.bootstrap4.min.js"></script>
</head>
<body>

<div class="container">
  <h2 style="text-align: center;">Quản trị Voucher</h2>
	<div class="jumbotron container">
	  <div class="row form-group">
		<div class="col-sm-3">
		  <label for="voucher-code">Mã Voucher</label>
		</div>
		<div class="col-sm-9">
		  <input type="text" id="input-voucher-code" name="vouchercodes" placeholder="Voucher code"
			class="form-control">
		</div>
	  </div>
	  <div class="row form-group">
		<div class="col-sm-3">
		  <label for="discount">Phần trăm giảm giá</label>
		</div>
		<div class="col-sm-9">
		  <input type="number" id="input-discount" name="discount" placeholder="Discount" class="form-control">
		</div>
	  </div>
	  <div class="row form-group">
		<div class="col-sm-3">
		  <label for="note">Ghi chú</label>
		</div>
		<div class="col-sm-9">
		  <input type="text" id="input-note" name="note" placeholder="Note" class="form-control">
		</div>
	  </div>
	  <div class="row form-group">
		<div class="col-sm-3">
		  <label for="createDate">Ngày Tạo</label>
		</div>
		<div class="col-sm-9">
		  <input type="date" id="input-createDate" name="createDate" placeholder="Create Date" class="form-control">
		</div>
	  </div>
	  <div class="row form-group">
		<div class="col-sm-3">
		  <label for="updateDate">Ngày sửa</label>
		</div>
		<div class="col-sm-9">
		  <input type="date" id="input-updateDate" name="updateDate" placeholder="Update Date" class="form-control">
		</div>
	  </div>
	  <div class="row pull-right">
		<div class="col-sm-12">
		  <button id="btn-send" class="btn btn-info">Gửi</button>
		  <button id="delete-all" class="btn btn-danger">Xoá hết các mã giảm giá</button>
		</div>
	  </div>
	</div>
  <table class="table table-bordered table-striped table-hover" id="user-table">
    <thead>
      <tr>
        <th>STT</th>
        <th>Mã giảm giá</th>
        <th>Phần trăm giảm giá</th>
        <th>Ghi Chú</th>
        <th>Ngày tạo</th>
        <th>Ngày cập nhật</th>
		<th>Action</th>
      </tr>
  </table>
</div>
<!-- Modal -->
<div id="my-modal" class="modal" tabindex="-1" role="dialog">
	<div class="modal-dialog" role="document">
	  <div class="modal-content">
		<div class="modal-header">
		  <h5 class="modal-title">Chỉnh sửa đơn hàng</h5>
		  <button type="button" class="close" data-dismiss="modal" aria-label="Close">
			<span aria-hidden="true">&times;</span>
		  </button>
		</div>
		<div class="modal-body">
		  <div class="row" style="margin-top:10px">
			  <div class="col-sm-5">
				  <label for="">Mã giảm giá</label>
			  </div>
			  <div class="col-sm-7">
				  <input id="inp-maVoucher" type="text" class="form-control" placeholder="Mã giảm giá">
			  </div>
		  </div>
		  <div class="row" style="margin-top:10px">
			<div class="col-sm-5">
				<label for="">Phần trăm giảm giá</label>
			</div>
			<div class="col-sm-7">
				<input id="inp-phanTramGiamGia" type="text" class="form-control" placeholder="Phần trăm giảm giá">
			</div>
		</div>
		<div class="row" style="margin-top:10px">
			<div class="col-sm-5">
				<label for="">Ghi chú</label>
			</div>
			<div class="col-sm-7">
				<input id="inp-ghiChu" type="text" class="form-control" placeholder="Ghi chú">
			</div>
		</div>
		</div>
		<div class="modal-footer">
		  <button type="button" id="btn-close" class="btn btn-secondary" data-dismiss="modal">Quay lại</button>
		  <button type="button" id="btn-send-edit" class="btn btn-primary">Gửi</button>
		</div>
	  </div>
	</div>
  </div>
<script>
	$(document).ready(function(){
		/*** REGION 1 - Global variables - Vùng khai báo biến, hằng số, tham số TOÀN CỤC */
		var table = $("#user-table").DataTable({
			"columns": [
				{"data":"id"},
				{"data":"maVoucher"},
				{"data":"phanTramGiamGia"},
				{"data":"ghiChu"},
				{"data":"ngayTao"},
				{"data":"ngayCapNhat"},
				{"data":"action"},
			],
			"columnDefs":[
				{
					targets: 6,
					defaultContent: `
					<button class="btn btn-primary btn-edit">Sửa</button><button class="btn btn-danger btn-delete">Xoá</button>
					`
				}
			]
		})
		//Biến ID để sửa voucher
		var vIdEditVoucherObject = {
			id:"",
		};
		/*** REGION 2 - Vùng gán / thực thi hàm xử lý sự kiện cho các elements */
		//Gán sự kiện khi bấm nút Gửi
		$("#btn-send").on("click",function(){
			onBtnSendClick();
		});
		//Gán sự kiện khi bấm nút Sửa 
		$("#user-table").on("click",".btn-edit",function(){
			$("#my-modal").modal("show");
			onBtnEditClick(this);
		});
		//Gán sự kiện khi bấm nút xoá
		$("#user-table").on("click",".btn-delete",function(){
			onBtnDeleteClick(this);
		});
		//Gán sự kiện khi bấm nút gửi trong modal edit
		$("#btn-send-edit").on("click",function(){
			onBtnSendEditClick();
		});
		//Gán sự kiện khi bấm nút xoá hết các mã giảm giá 
		$("#delete-all").on("click",function(){
			onBtnDeleteAllClick();
		})
		/*** REGION 3 - Event handlers - Vùng khai báo các hàm xử lý sự kiện */
		onPageLoading();
		/*** REGION 4 - Common funtions - Vùng khai báo hàm dùng chung trong toàn bộ chương trình*/
		//Hàm tải trang
		function onPageLoading(){
			"use strict"
			$.ajax({
			url: "http://localhost:8080/api/vouchers",
			type: "GET",
			dataType: "json",
			success: function(res){
				console.log(res);
				table.clear();
				table.rows.add(res);
				table.draw();
			},
			error: function(err){
				console.log(err.response);
			}
		});
		}
		//Hàm xử lý sự kiện khi bấm nút send :
		function onBtnSendClick(){
			"use strict"
			//Bước 1 : tạo object để thu thập dữ liệu
			var vDataObject = {
				maVoucher: "",
				phanTramGiamGia: "",
				ghiChu:"",
			}
			//Bước 2 : Thu thập dữ liệu :
			getDataObject(vDataObject);
			//Bước 3 : Kiểm tra dữ liệu 
			if(validateData(vDataObject) == true){
				//Bước 4 : Call sever để lấy dữ liệu :
				console.log("Dữ liệu đạt chuẩn");
				$.ajax({
					url:"http://localhost:8080/api/vouchers",
					type: "POST",
					contentType:"application/json",
					data: JSON.stringify(vDataObject),
					success: function(responseObject){
						console.log(responseObject);
					},
					error: function(error){
						console.log(error.responseText);
					}
				});
			}
		}
		//Hàm thu thập dữ liệu ;
		function getDataObject(paramObject){
			"use strict"
			paramObject.maVoucher = parseInt($("#input-voucher-code").val());
			paramObject.phanTramGiamGia = parseInt($("#input-discount").val());
			paramObject.ghiChu = $("#input-note").val();
			console.log(paramObject);
		}
		//Hàm kiểm tra dữ liệu :
		function validateData(paramObject){
			"use strict"
			if(paramObject.maVoucher == ""){
				console.log("Chưa điền mã voucher");
				return false;
			}
			if(paramObject.phanTramGiamGia == ""){
				console.log("Chưa điền phần trăm giảm giá");
				return false;
			}
			if(isNaN(paramObject.phanTramGiamGia) == true){
				console.log("Phần trăm giảm giá phải là một số");
				return false;
			}
			if(isNaN(paramObject.maVoucher) == true){
				console.log("Mã giảm giá phải là một số");
				return false;
			}
			return true;
		}
		//Hàm xử lý sự kiện khi bấm nút edit
		function onBtnEditClick(paramButton){
			"use strict"
			var vRowClick = $(paramButton).closest("tr");
			var vDataTable = $("#user-table").DataTable();
			var vDataRowClick = vDataTable.row(vRowClick).data();
			vIdEditVoucherObject.id = vDataRowClick.id;
			$("#inp-maVoucher").val(vDataRowClick.maVoucher);
			$("#inp-phanTramGiamGia").val(vDataRowClick.phanTramGiamGia);
			$("#inp-ghiChu").val(vDataRowClick.ghiChu);
			
		}
		//Hàm xử lý sự kiện khi bấm nút xoá
		function onBtnDeleteClick(paramButton){
			"use strict"
			var vRowClick = $(paramButton).closest("tr");
			var vDataTable = $("#user-table").DataTable();
			var vDataRowClick = vDataTable.row(vRowClick).data();
			var vId = vDataRowClick.id;
			console.log(vId);
			//Gọi sever để xoá voucher 
			$.ajax({
				url:"http://localhost:8080/api/vouchers/" + vId,
				type: "DELETE",
				success: function(responseObject){
					console.log(responseObject);
					alert("Xoá voucher có id là: " + vId + " thành công")
				},
				error: function(error){
					console.log(error.responseText);
				}
			});
		}
		//Hàm lấy dữ liệu cho edit object 
		function getDataEditObject(paramObject){
			"use strict"
			paramObject.maVoucher = parseInt($("#inp-maVoucher").val());
			paramObject.phanTramGiamGia = parseInt($("#inp-phanTramGiamGia").val());
			paramObject.ghiChu = $("#inp-ghiChu").val();
		}
		//hàm xử lý sụe kiện khi bấm nút send trong modal edit
		function onBtnSendEditClick(){
			"use strict"
			//Bước 1: Tạo object để chứa thông tin dữ liệu 
			var vEditObject = {
				maVoucher: "",
				phanTramGiamGia: "",
				ghiChu:"",
			}
			//Bước 2 : Thu thập dữ liệu :
			getDataEditObject(vEditObject);
			//Bước 3 : Validate dữ liệu 
			if(validateData(vEditObject)){
				//Bước 4 : Gọi sever để update voucher :
				$.ajax({
					url: "http://localhost:8080/api/vouchers/" + vIdEditVoucherObject.id,
					type:"PUT",
					contentType: "application/json",
					data: JSON.stringify(vEditObject),
					success: function(responseObject){
						console.log(responseObject);
						alert("Cập nhật thông tin voucher thành công");
					},
					error: function(error){
						console.log(error.responseText);
					}
				})
			}
		}
		//Hàm xử lý sự kiện khi bấm nút xoá tất cả các mã giảm giá
		function onBtnDeleteAllClick(){
			"use strict"
			$.ajax({
				url: "http://localhost:8080/api/vouchers/",
				type: "DELETE",
				success: function(succcess){
					alert("Xoá tất cả mã giảm giá thành công");
				},
				error: function(error){
					console.log(error.responseText);
				}
			})
		}
	});
</script>
</body>
</html>
